#!/bin/bash

. runcommon.sh

mydir=$(realpath $(dirname $0))/..

export LC_ALL=en_US.UTF-8

for SZ in $SZS; do
    for cr in $CRS; do
	for U in $UTILS; do
	    suff=sz$SZ-cr$cr-aagg-u$U-dev
	    cat > draw-miss-d-$suff.gp <<EOF
#!/usr/bin/gnuplot

set terminal pdf mono enhanced
set output 'miss-d-$suff.pdf'

set grid
set xlabel 'a'
set ylabel 'deadline hit ratio'
set title 'sz=$SZ cr=$cr U=$U'
set xtics 0.05
#set style histogram errorbars
# u 8:(\$9*1.0):xtic(3)

set key bottom center
set size 1,0.75

plot [] [0:1.2] \
     "< grep -e '^$SZ $cr [0-9.]\\\\+ $U d-cbs3 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-6 --no-avg --sum --no-header | awk '{ print \$1,\$2,\$3,\$4,\$5,\$6,\$11/\$14 }' | $mydir/datastat -k 1-5 --dev --no-header" u 3:8:(\$9*1.0) t 'H-CBS^D-W' w lp lw 2 pt 4, \
     "< grep -e '^$SZ $cr [0-9.]\\\\+ $U d-cbs2 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-6 --no-avg --sum --no-header | awk '{ print \$1,\$2,\$3,\$4,\$5,\$6,\$11/\$14 }' | $mydir/datastat -k 1-5 --dev --no-header" u 3:8:(\$9*1.0) t 'H-CBS^D' w lp lw 2 pt 6, \
     "< grep -e '^$SZ $cr [0-9.]\\\\+ $U d-cbs5 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-6 --no-avg --sum --no-header | awk '{ print \$1,\$2,\$3,\$4,\$5,\$6,\$11/\$14 }' | $mydir/datastat -k 1-5 --dev --no-header" u 3:8:(\$9*1.0) t 'H-CBS^D-R' w lp lw 2 pt 8, \
     "< grep -e '^$SZ $cr [0-9.]\\\\+ $U d-cbs3 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-6 --no-avg --sum --no-header | awk '{ print \$1,\$2,\$3,\$4,\$5,\$6,\$11/\$14 }' | $mydir/datastat -k 1-5 --dev --no-header" u 3:8:(\$9*1.0) t '' w errorbars pt 0 lw 1, \
     "< grep -e '^$SZ $cr [0-9.]\\\\+ $U d-cbs2 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-6 --no-avg --sum --no-header | awk '{ print \$1,\$2,\$3,\$4,\$5,\$6,\$11/\$14 }' | $mydir/datastat -k 1-5 --dev --no-header" u 3:8:(\$9*1.0) t '' w errorbars pt 0 lw 1, \
     "< grep -e '^$SZ $cr [0-9.]\\\\+ $U d-cbs5 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-6 --no-avg --sum --no-header | awk '{ print \$1,\$2,\$3,\$4,\$5,\$6,\$11/\$14 }' | $mydir/datastat -k 1-5 --dev --no-header" u 3:8:(\$9*1.0) t '' w errorbars pt 0 lw 1
EOF
	    gnuplot draw-miss-d-$suff.gp
	done
    done
done
