#!/bin/bash

. runcommon.sh

mydir=$(realpath $(dirname $0))/..

export LC_ALL=en_US.UTF-8

for alpha in $ALPHAS; do
    for U in $UTILS; do
	suff=szagg-cragg-a$alpha-u$U-3d
	cat > draw-miss-d-$suff.gp <<EOF
#!/usr/bin/gnuplot

set terminal pdf mono enhanced
set output 'miss-d-$suff.pdf'

set grid
set xlabel 'CR'
set ylabel 'SZ'
#set zlabel "deadline\nhit\nratio"
set title 'deadline hit ratio (a=$alpha, U=$U)'
set hidden3d
set ticslevel 0

set xtics 0.1
set ytics 0.05
set ztics 0.1

splot [0.7:][0.6:] \
     "< grep -e '^[0-9.]\\\\+ [0-9.]\\\\+ $alpha $U d-cbs3 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-5 --no-avg --sum --no-header | sort -k2 -n | awk 'BEGIN { v=\$2; } { if (\$2 != v) { print \"\"; v=\$2; } print \$0; }'" u 2:1:(\$11/\$14) t 'H-CBS^D-W' w l lt 3, \
     "< grep -e '^[0-9.]\\\\+ [0-9.]\\\\+ $alpha $U d-cbs2 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-5 --no-avg --sum --no-header | sort -k2 -n | awk 'BEGIN { v=\$2; } { if (\$2 != v) { print \"\"; v=\$2; } print \$0; }'" u 2:1:(\$11/\$14) t 'H-CBS^D' w l lt 2, \
     "< grep -e '^[0-9.]\\\\+ [0-9.]\\\\+ $alpha $U d-cbs5 ' results.dat | grep 'Task0[0369]' | sed -e 's/Task//g' -e 's/Stream//' -e 's/[[:blank:]]\\\\+/ /g' | $mydir/datastat -k 1-5 --no-avg --sum --no-header | sort -k2 -n | awk 'BEGIN { v=\$2; } { if (\$2 != v) { print \"\"; v=\$2; } print \$0; }'" u 2:1:(\$11/\$14) t 'H-CBS^D-R' w l lt 1
EOF
	gnuplot draw-miss-d-$suff.gp
    done
done
