#include <iostream>
#include <random>
#include <fstream>
#include <sstream>

double u(unsigned int v)
{
  return rand() % v;
}

void do_out(unsigned int c, unsigned int p, double beta)
{
  unsigned int d;

  d = c + beta * (p - c) + u((1 - beta) * (p - c)); 

  std::cout << c << " " << d << " " << p << std::endl;
}

int process(const char *fname, double beta)
{
  std::ifstream in(fname);
  unsigned int n;

  n = 0;
  while(!in.eof()) {
    char line[80];

    in.getline(line, 80);
    if (!in.eof()) {
      std::stringstream inl(line);
      unsigned int c_i, p_i;

      inl >> c_i >> p_i;
      if (!inl.fail()) {
        do_out(c_i, p_i, beta);
        n = n + 1;
      }
    }
  }

  return n;
}

int main(int argc, char *argv[])
{
  if (argc < 2) {
    std::cerr << "Usage: " << argv[0] << " <filename>\n";

    return -1;
  }
  if (argc > 2) {
    srand(atoi(argv[2]));
  }

  process(argv[1], 0.4);

  return 0;
}
