#!/bin/bash

mydir=$(realpath $(dirname $0))

. ./runcommon.sh

generate_ts() {
  $mydir/taskgen.py -S $1 -d logunif -s 1 -n $N -u $U -p 5000 -q 500000 -g 1000 --round-C -f "%(C)d %(T)d\n"
}

for I in $(seq 1 $S); do
  echo "Generating Taskset $I"
  generate_ts $I > ts$I.txt
  echo -e "\tConstraining deadlines"
  $mydir/dgen ts$I.txt > ts$I-d.txt
  $mydir/schedcheck ts$I-d.txt > schedulable-$I.txt &&
      echo -e "\tSchedulable" ||
      echo -e "\tNot Schedulable"
done 
