#!/bin/bash

mydir=$(realpath $(dirname $0))

. ./runcommon.sh

SIMDIR=${SIMDIR:-$mydir/../Simulator}
echo SIMDIR=$SIMDIR

# -2 CBS nuovo
# -3 CBS SO

mycpus=$(grep -c processor /proc/cpuinfo)

function pexec {
    while [ $(pidof srv-taskset | wc -w) -ge $[$mycpus*15/10] -o $(pidof srv-taskset | wc -w) -ge $[$mycpus*15/10] ]; do
	sleep $(echo "$RANDOM * 5 / 32767" | bc -l)
    done
    echo "Running $@ ..."
    eval "$@" &
}

#rm -f times.txt
for I in $(seq 1 $S); do
    echo TS$I:

    if grep NOT schedulable-$I.txt > /dev/null; then
	echo "SKIPPING schedulable-$I.txt NON sched"
    else
	# if grep "Closing taskset" 2>&1 > /dev/null res$I-cbs.txt; then
	#     echo "Skipping already existing and complete res$I-cbs.txt"
	# else
	#     opts="-C $cr -A $alpha -S $SZ ts$I.txt      -R -p 10000000000"
	#     echo            CBS: $opts
	#     pexec time $SIMDIR/CPU/Tests/srv-taskset $opts > res$I-cbs.txt
	# fi

	# if grep "Closing taskset" 2>&1 > /dev/null res$I-cbs2.txt; then
	#     echo "Skipping already existing and complete res$I-cbs2.txt"
	# else
	#     opts="-C $cr -A $alpha -S $SZ ts$I.txt   -2 -R -p 10000000000"
	#     echo            CBS2: $opts
	#     pexec time $SIMDIR/CPU/Tests/srv-taskset $opts> res$I-cbs2.txt
	# fi

	# if grep "Closing taskset" 2>&1 > /dev/null res$I-cbs3.txt; then
	#     echo "Skipping already existing and complete res$I-cbs3.txt"
	# else
	#     opts="-C $cr -A $alpha -S $SZ ts$I.txt   -3 -R -p 10000000000"
	#     echo            CBS-SO: $opts
	#     pexec time $SIMDIR/CPU/Tests/srv-taskset $opts > res$I-cbs3.txt
	# fi

	if grep "Closing taskset" 2>&1 > /dev/null res$I-d-cbs2.txt; then
	    echo "Skipping already existing and complete res$I-d-cbs2.txt"
	else
	    opts="-C $cr -A $alpha -S $SZ ts$I-d.txt -2 -R -p 10000000000"
	    echo            CBS2 D!=P: $opts
	    pexec time $SIMDIR/srv-taskset $opts > res$I-d-cbs2.txt
	fi

	if grep "Closing taskset" 2>&1 > /dev/null res$I-d-cbs3.txt; then
	    echo "Skipping already existing and complete res$I-d-cbs3.txt"
	else
	    opts="-C $cr -A $alpha -S $SZ ts$I-d.txt -3 -R -p 10000000000"
	    echo            CBS-SO D!=P: $opts
	    pexec time $SIMDIR/srv-taskset $opts > res$I-d-cbs3.txt
	fi

	if grep "Closing taskset" 2>&1 > /dev/null res$I-d-cbs5.txt; then
	    echo "Skipping already existing and complete res$I-d-cbs5.txt"
	else
	    opts="-C $cr -A $alpha -S $SZ ts$I-d.txt -5 -R -p 10000000000"
	    echo            CBS-5 D!=P: $opts
	    pexec time $SIMDIR/srv-taskset $opts> res$I-d-cbs5.txt
	fi
    fi
done

echo "Joining spawned children..."
wait
