#include <iostream>
#include <cstring>
#ifdef DEVEL
#undef NDEBUG
#endif
#include <cassert>

#include "dbg.hh"
#include "simobject.hh"
#include "queuableentity.hh"
#include "priorityqueue.hh"
#include "event.hh"
#include "eventlist.hh"
#include "randomvar.hh"
#include "sporadicevent.hh"
#include "statobject.hh"
#include "stat.hh"
#include "waitobject.hh"
#include "waitstat.hh"
#include "avgobject.hh"
#include "event.hh"
#include "job.hh"
#include "kernel.hh"
#include "task.hh"
#include "cpu.hh"
#include "server.hh"

#include "budget_server.hh"

void BudgetServer::action(long long int, Event*)
{
}

void BudgetServer::do_accounting(long long int t)
{
  assert(last_dispatch_time >= 0);

  DBG("\tt " << t <<" - last_Dispatch_time " << last_dispatch_time << std::endl);
  budget -= (t - last_dispatch_time);
  last_dispatch_time = -1;
}

int BudgetServer::getBudget(long long int t)
{
  if (last_dispatch_time < 0) return budget;

  return budget - (t - last_dispatch_time);
}

void BudgetServer::dispatch(long long int t)
{	
  DBG("BUDGET_SERVER " << name << " DISPATCHED at time " << t << std::endl);

  assert(current);
  assert(bandwidthExhaust == NULL);
  assert(last_dispatch_time < 0);

  bandwidthExhaust = new Event(t + budget);
  bandwidthExhaust->setObject(this);
  eventlist->insert(bandwidthExhaust);

  last_dispatch_time = t;
	
//std::cout << "Server " << name << " DISPATCHED - ready size: " << ready.getSize() << " at time " << t << std::endl;

  Server::dispatch(t);
}

void BudgetServer::preempt(long long int t)
{	
  DBG("BUDGET SERVER " << name << " PREEMPTED at time " << t << std::endl);
  
  assert(bandwidthExhaust);

  if(eventlist->remove(bandwidthExhaust)) {
    delete bandwidthExhaust;
  } else {
    DBG("\tbandwidthExhaust not in eventlist???\n");
  }
  bandwidthExhaust = NULL;

  Server::preempt(t);

  do_accounting(t);
}

BudgetServer::~BudgetServer(void)
{
}
