#ifndef BUDGETSERVER_H
#define BUDGETSERVER_H

class BudgetServer : public Server {
  private:
    long long int last_dispatch_time;
    void do_accounting(long long int t);
  protected:
    int getBudget(long long int t);
    const unsigned int Q, P;
    int budget;
    Event* bandwidthExhaust;
  public:
    BudgetServer(unsigned int max_budget, unsigned int period, Kernel *k, EventList *l) : Server(k, l), Q(max_budget), P(period) {
      last_dispatch_time = -1;
      bandwidthExhaust = NULL;
    };
    virtual void action(long long int time, Event *e);
    virtual void dispatch(long long int t);
//    using Server::dispatch; //(Task *task, long long int t);
    virtual void preempt(long long int t);
    ~BudgetServer(void);
};

#endif	/* BUDGETSERVER_H */
