#ifndef CBSERVER_H
#define CBSERVER_H

class CBServer : public BudgetServer
{
  private:
    void rechargeBandwidth(long long int t);
  protected:
    long long int scheduling_deadline;
  public:
    CBServer(unsigned int max_budget, unsigned int period, Kernel *k, EventList *l) : BudgetServer(max_budget, period, k, l) {
      scheduling_deadline = 0;
    };
    virtual void action(long long int time, Event *e);
    virtual void dispatch_task(Task *task, long long int t);
    virtual long long int getAbsDeadline(void) {
      return scheduling_deadline;
    };
    virtual void preempt(long long int t);
};

#endif	/* CBSERVER_H */

