#include <cstdlib>
#ifdef DEVEL
#undef NDEBUG
#endif
#include <cassert>

#include "simobject.hh"
#include "queuableentity.hh"
#include "priorityqueue.hh"
#include "event.hh"
#include "eventlist.hh"
#include "randomvar.hh"
#include "sporadicevent.hh"
#include "statobject.hh"
#include "stat.hh"
#include "waitobject.hh"
#include "waitstat.hh"
#include "avgobject.hh"
#include "event.hh"
#include "job.hh"
#include "kernel.hh"
#include "task.hh"
#include "cpu.hh"

int CPU::cpu_id;

void CPU::prepare_dispatch(Task *task, long long int t)
{
  old_exec = current;
  current = task;
  if (old_exec != current) {
    if (old_exec) old_exec->preempt(t);
  }
}

void CPU::finish_dispatch(long long int t)
{
  if (old_exec != current) {
    if (current) {
      if (idleStat && old_exec == NULL) {
        idleStat->end(t);
      }
      current->cpu = cid;
      current->dispatch(t); 
    } else if (idleStat) {
      idleStat->start(t);
    }
  }
}

void CPU::dispatch_task(Task *task, long long int t)
{
  prepare_dispatch(task, t);
  finish_dispatch(t);
}
