#ifndef __GMQDELAYEDPRIORITYKERNEL_H__
#define __GMQDELAYEDPRIORITYKERNEL_H__

class GMQDelayedPriorityKernel: public GMQPriorityKernel, public SimObject
{
  private:
    uint64_t pull_mask;
    uint64_t push_mask;
    Event *delayed_pushpull;
    EventList *el;
    int delta;
    int pushSchedule(int cpu, long long int t);
    int pullSchedule(int cpu, long long int t);
  public:
    virtual void unblock(Task *task, long long int t);
    virtual void block(Task *task, long long int t);
    GMQDelayedPriorityKernel(CPU *c, int m, EventList *l) : GMQPriorityKernel(c, m) {pull_mask = 0; push_mask = 0; delayed_pushpull = NULL; el = l; delta = 0;};
    void setDelay(int i) {delta = i;};
    virtual void action(long long int time, Event *e);
};

#endif	/* __GMQDELAYEDPRIORITYKERNEL_H__ */
