#ifndef HCBSERVER_SO_H
#define HCBSERVER_SO_H

class HCBServerSO : public HCBServer
{
  private:
    class SuspendedServer: public QueuableEntity {
      public:
        void setDeadline(long long int d) {priority = -d;};
        HCBServerSO *s;
    };

    static PriorityQueue ss_queue;
    static SuspendedServer *ss_first;
    static long long int start_accounting_time;
    static long long int current_scheduling_deadline;
    static Event *ssExhaust;
    SuspendedServer *suspended;
    void ss_account(long long int time);
    void ss_start_accounting(long long int time);
    void ss_insert(long long int time);
    void ss_remove(long long int time);
    const unsigned int D;
  public:
    HCBServerSO(unsigned int max_budget, unsigned int deadline, unsigned int period, Kernel *k, EventList *l) : HCBServer(max_budget, period, k, l),D(deadline) {
      suspended = new SuspendedServer;
      suspended->s = this;
      scheduling_deadline = (long long int)D - (long long int)P;
      budget = 0;
    };
    virtual void dispatch_task(Task *task, long long int t);
    virtual void dispatch(long long int t);
    virtual void action(long long int time, Event *e);
    virtual void preempt(long long int t);
};

#endif	/* HCBSERVER_SO_H */



