#include <iostream>
#include <cstring>
#ifdef DEVEL
#undef NDEBUG
#endif
#include <cassert>

#include "dbg.hh"
#include "simobject.hh"
#include "queuableentity.hh"
#include "priorityqueue.hh"
#include "event.hh"
#include "eventlist.hh"
#include "randomvar.hh"
#include "sporadicevent.hh"
#include "statobject.hh"
#include "stat.hh"
#include "waitobject.hh"
#include "waitstat.hh"
#include "avgobject.hh"
#include "event.hh"
#include "job.hh"
#include "kernel.hh"
#include "task.hh"
#include "cpu.hh"
#include "server.hh"
#include "budget_server.hh"
#include "cbserver.hh"

#include "hcbserver.hh"

void HCBServer::action(long long int time, Event *e)
{
  if (e == bandwidthExhaust) {
    DBG("HCBS " << name << " depleted at time " << time << std::endl);
    kernel->block(this, time);
    replenish = new Event(scheduling_deadline);
    replenish->setObject(this);
    eventlist->insert(replenish);
  }

  if (e == replenish) {
    DBG("HCBS " << name << " replenishing at time " << time << std::endl);
    scheduling_deadline += P;
    budget              += Q;

    kernel->unblock(this, time);
  }
}

