#ifndef HCBSERVER2_H
#define HCBSERVER2_H

class HCBServer2 : public HCBServer, public AccountableEntity 
{
  private:
    double dbf1(unsigned int q, long long int d, long long int t, HCBServer2 *pi);
  protected:
    long long int last_activation_time;
    const unsigned int D;
    void select(HCBServer2 *pi, unsigned int q, long long int d, double t, double &qs, long long int &deadline);
    long long int keep, budget0_1, budget0, newdl, total_activations;
    bool check(unsigned int q, long long int d, long long int t);
  public:
    HCBServer2(unsigned int max_budget, unsigned int deadline, unsigned int period, Kernel *k, EventList *l) : HCBServer(max_budget, period, k, l),D(deadline) {
      keep = budget0_1 = budget0 = newdl = total_activations = 0;
      scheduling_deadline = (long long int)D - (long long int)P;
      budget = 0;
    };
    virtual void dispatch_task(Task *task, long long int t);
    virtual void dispatch(long long int t);
    virtual void action(long long int time, Event *e);
    ~HCBServer2(void) {
      std::cout << "HCBServer2 " << name << ": ";
      std::cout << budget0_1 << ", ";
      std::cout << budget0   << ", ";
      std::cout << keep      << ", ";
      std::cout << newdl << " / " << total_activations << std::endl;
    };
};

#endif	/* HCBSERVER2_H */


