#include <cstdlib>
#ifdef DEVEL
#undef NDEBUG
#endif
#include <cassert>

#include "simobject.hh"
#include "queuableentity.hh"
#include "event.hh"
#include "randomvar.hh"
#include "priorityqueue.hh"
#include "eventlist.hh"
#include "sporadicevent.hh"
#include "statobject.hh"
#include "waitobject.hh"
#include "avgobject.hh"
#include "job.hh"
#include "task.hh"
#include "kernel.hh"
#include "cpu.hh"
#include "prioritykernel.hh"
#include "mqprioritykernel.hh"

void MQPriorityKernel::unblock(Task *task, long long int t)
{
  assert(task->cpu >= 0);
  assert(task->cpu < n_cpus);

  q[task->cpu]->unblock(task, t);
}

void MQPriorityKernel::block(Task *task, long long int t)
{
  assert(task->cpu >= 0);
  assert(task->cpu < n_cpus);

  q[task->cpu]->block(task, t);
}

MQPriorityKernel::MQPriorityKernel(CPU *cpu, int m)
{
  int i;

  n_cpus = m;
  cpus = cpu;
  q = new PriorityKernel*[m];

  for (i = 0; i < m; i++) {
    q[i] = new PriorityKernel(&cpu[i]);
  }
}

MQPriorityKernel::~MQPriorityKernel(void)
{
  int i;

  for (i = 0; i < n_cpus; i++) {
    delete q[i];
  }
  delete[] q;
}
