#include <cstdlib>
#ifdef DEVEL
#undef NDEBUG
#endif
#include <cassert>

#include "simobject.hh"
#include "queuableentity.hh"
#include "event.hh"
#include "randomvar.hh"
#include "priorityqueue.hh"
#include "eventlist.hh"
#include "sporadicevent.hh"
#include "statobject.hh"
#include "waitobject.hh"
#include "avgobject.hh"
#include "job.hh"
#include "task.hh"
#include "kernel.hh"
#include "cpu.hh"
#include "prioritykernel.hh"

Task *PriorityKernel::schedule(void)
{
  return CAST(ready.popFirst(), Task *);
}

void PriorityKernel::unblock(Task *task, long long int t)
{
  ready.insert(task);
  if (cpu->exec()) ready.insert(cpu->exec());
  cpu->dispatch_task(schedule(), t);
}

void PriorityKernel::block(Task *task, long long int t)
{
  assert (cpu->exec() == task);
  cpu->dispatch_task(schedule(), t);
}

