#ifndef __PRIORITYKERNEL_H__
#define __PRIORITYKERNEL_H__

class PriorityKernel: public Kernel
{
  private:
    CPU *cpu;
    PriorityQueue ready;
    Task *schedule(void);
  public:
    PriorityKernel(CPU *c) {cpu = c;};
    virtual void unblock(Task *task, long long int t);
    virtual void block(Task *task, long long int t);
    Task *getNext(void) {
      Task *next = schedule();
      return next;
    }
    void putTask(Task *t) {ready.insert(t);}
};

#endif	/* __PRIORITYKERNEL_H__ */
