#ifndef TASK_H
#define TASK_H

#define trace(action, task, time)

class Kernel;
class Task: public SimObject, public QueuableEntity {
  private:
    long long int dispatch_time;
    static int task_id;
    int old_cpu;
  protected:
    /* Used by Task2 */
    RandomVar *exec;
    int relative_deadline;
    PriorityQueue pending_jobs;
    AvgObject *migrations;
    WaitObject *response_time;

    /* Used by Server */
    EventList *eventlist;
    Kernel *kernel;
    SporadicEvent *arrival;
    Job *current_job;
    int id;
    Task(Kernel *k, EventList *l);
  public:
    char name[16];
    int cpu;
    Task(RandomVar *c, RandomVar *interarrival, int dl, Kernel *k, EventList *l);
    ~Task(void);
    virtual void action(long long int time, Event *e);
    virtual void dispatch(long long int t);
    virtual void preempt(long long int t);
    void setR(WaitObject *r) {response_time = r;};
    void setM(AvgObject  *m) {migrations    = m;};
    void setPriority(long long int prio) {priority = prio;};
    virtual long long int getAbsDeadline(void) {return current_job->r + relative_deadline;};
    virtual bool operator<(const QueuableEntity &other) const {
      if (this->priority == CAST(other, const Task &).priority) {
        return this->id < CAST(other, const Task &).id;
      }
      return this->priority > CAST(other, const Task &).priority;
    };
};

#endif /* TASK_H */

