#include <cstdlib>
#include <cstring>
#ifdef DEVEL
#undef NDEBUG
#endif
#include <cassert>

#include "simobject.hh"
#include "queuableentity.hh"
#include "priorityqueue.hh"
#include "event.hh"
#include "eventlist.hh"
#include "randomvar.hh"
#include "sporadicevent.hh"
#include "statobject.hh"
#include "stat.hh"
#include "waitobject.hh"
#include "waitstat.hh"
#include "avgobject.hh"
#include "event.hh"
#include "job.hh"
#include "kernel.hh"
#include "task.hh"
#include "task2.hh"

void Task2::action(long long int time, Event *e)
{
  if (e == arrival) {
    Job *j;

    j = new Job(time, exec->sample() / 4, time + relative_deadline, NULL);

    trace(arrival, this, time);
//std::cerr << "Wake " << name << " up at time " << time << std::endl;
    if (current_job) {
      pending_jobs.insert(j);
    } else {
      assert(phase == 0);
      current_job = j;
      kernel->unblock(this, time);
    }
  } else if (current_job && e == current_job->end) {
//std::cerr << "Job of task " << name << " (" << current_job->r << ") finishing ar time " << time << std::endl;
    phase++;
    if (phase == 2) {
      trace(finish, this, time);
      current_job->finish(time);
      kernel->block(this, time);
      delete current_job;
      if (migrations) migrations->reset();
      current_job = CAST(pending_jobs.popFirst(), Job *);
      if (current_job) {
        kernel->unblock(this, time);
      }
      phase = 0;
    } else {
      Job *j  = new Job(current_job->r, exec->sample() * 3 / 4, current_job->r + relative_deadline, response_time);
      assert(unblock == NULL);
      unblock = new Event(time + blocking_time->sample());
      unblock->setObject(this);	// FIXME?
      eventlist->insert(unblock);
      kernel->block(this, time);
      delete current_job;
      current_job = j;
    }
  } else if (current_job && e == unblock) {
    assert(current_job != NULL);
    kernel->unblock(this, time);
    unblock = NULL;
  } else {
    abort();
  }
}

Task2::Task2(RandomVar *c, RandomVar *interarrival, RandomVar *suspension, int dl, Kernel *k, EventList *l) : Task(c, interarrival, dl, k, l)
{
  blocking_time = suspension;
}
