#ifndef TASKSET
#define TASKSET

class TaskSet {
  public:
    enum StatType {stat_average, stat_distribution, stat_dlmiss};
    TaskSet(const char *fname);
    TaskSet(void) {
      prio  = NULL;
      tasks = NULL;
      c     = NULL;
      p     = NULL;
      d     = NULL;
      trc   = NULL;
      rstat = NULL;
      mstat = NULL;
    };
    unsigned int getSize(void);
    void setTracer(Tracer *t) {trc = t;};
    int addToKernel(Kernel *k, EventList *l);
    unsigned long long int getHyperPeriod(void);
    WaitObject **getRStat(StatType type, unsigned int scale = 1);
    AvgObject **getMStat(StatType type);
    ~TaskSet();
    void print(std::ostream &o);
  protected:
    static const int max_tasks = 20;
    int *prio;
    Task **tasks;
    RandomVar **c;
    RandomVar **p;
    unsigned int *d;
    unsigned long long int hyper_p;
    Tracer *trc;
    unsigned int size;
    //WaitObject *rstat;
    WaitObject **rstat;
    AvgObject **mstat;
    StatType rtype;
    StatType mtype;
    bool deterministic_task(const char *l, unsigned int *c_i, unsigned int *d_i, unsigned int *p_i);
    bool probabilistic_task(const char *l, char *fname, unsigned int *d_i, unsigned int *p_i);
    unsigned long long int lcm(unsigned long long int a, unsigned long long int b);
};

#endif	/* TASKSET */
