class TracedTask: public Task {
  private:
    Tracer *trc;
  public:
    TracedTask(RandomVar *c, RandomVar *interarrival, int dl, Kernel *k, EventList *l, Tracer *t): Task(c, interarrival, dl, k, l) {trc = t, trc->TaskCreate(id, name, 0);};
    ~TracedTask(void) {};
    virtual void action(long long int time, Event *e) {
      if (e == arrival) {
        trc->JobStart(id, time);
      } else if (current_job && e == current_job->end) {
        trc->JobFinish(id, time);
      }
      Task::action(time, e);
    };
    virtual void dispatch(long long int t) {
      trc->TaskDispatch(id, cpu, t);
      Task::dispatch(t);
    };
    virtual void preempt(long long int t) {
      trc->TaskPreempt(id, t);
      Task::preempt(t);
    };
};
