#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdlib>

#include "randomvar.hh"
#include "detvar.hh"

#define SIZE_CHUNK 100

DetVar::DetVar(const char *filename)
{
  std::ifstream in(filename);
  int size;

  size = SIZE_CHUNK;
  values = (double *)malloc(sizeof(double) * size);
  n = 0;
  pos = 0;
  while(in >> values[n])
  {
    n++;
    if (n == size) {
      size += SIZE_CHUNK;
      values = (double *)realloc(values, sizeof(double) * size);
    }
  }
}

long long int DetVar::sample(void)
{
  if(n == 0 || pos == n) {
    return -1;
  }
	
  return values[pos++];
}

void DetVar::dump(char *buff)
{
  std::stringstream out;

  out.rdbuf()->pubsetbuf(buff, 32/*FIXME!*/);
  out << "DetVar";
}
