#include <cstdlib>

#include "queuableentity.hh"
#include "priorityqueue.hh"
#include "statobject.hh"
#include "distribution.hh"

bool Distribution::check_value(QueuableEntity *p, void *dist)
{
  Element *e = CAST(p, Element *);
  Distribution *myself = (Distribution *)(dist);

  if (e->value == myself->tmp_value) {
    myself->tmp_element = e;

    return false;
  }

  return true;
}

bool Distribution::get_value(QueuableEntity *p, void *dist)
{
  Element *e = CAST(p, Element *);
  Distribution *myself = (Distribution *)(dist);

  return myself->tmp_fn(e->value, (double)e->weight / (double)myself->n);
}

void Distribution::submit(double val)
{
  long long int x = val - base;
  int m = x % scale;

  if (m < 0) m += scale;
  if (m) x += (scale - m);
  x += base;
  n++;
  tmp_value = x;
  tmp_element = NULL;
  q.process(Distribution::check_value, this);
  if (tmp_element) {
    CAST(tmp_element, Element *)->weight++;
  } else {
    Element *e = new Element(x);
    q.insert(e);
  }
}

double Distribution::getP(long long int x)
{
  tmp_value = x;
  tmp_element = NULL;
  q.process(check_value, this);
  if (tmp_element) {
    return (double)CAST(tmp_element, Element *)->weight / (double)n;
  }

  return 0;
}

void Distribution::process(bool (*f)(long long int v, double p))
{
  tmp_fn = f;
  q.process(get_value, this);
}

Distribution::~Distribution()
{
  Element *e = CAST(q.popFirst(), Element *);

  while (e) {
    delete e;
    e = CAST(q.popFirst(), Element *);
  }
}
