#ifndef DISTRIBUTION_H
#define DISTRIBUTION_H

class Distribution: virtual public StatObject {
    class Element: public QueuableEntity {
      public:
        Element(long long int v) {weight = 1; value = v;};
        virtual bool operator<(const QueuableEntity &other) const {
          return this->value < CAST(other, const Element &).value;
        }
        long long int value;
        long long int weight;
    };
    long long int tmp_value;
    QueuableEntity *tmp_element;
    bool (*tmp_fn)(long long int v, double p);
    static bool check_value(QueuableEntity *p, void *dist);
    static bool get_value(QueuableEntity *p, void *dist);
    class PriorityQueue q;
    int n;
    unsigned int scale;
    unsigned int base;
  protected:
    virtual void submit(double val);
  public:
    Distribution(void) {n = 0; scale = 1; base = 0;};
    Distribution(unsigned int s) {n = 0; scale = s; base = 0;};
    Distribution(unsigned int s, unsigned int b) {n = 0; scale = s; base = b;};
    virtual ~Distribution();
    double getP(long long int x);
    void process(bool (*f)(long long int v, double p));
    long long int getN(void) {return n;};
    //class Iterator getIterator(void);
};

#endif /* DISTRIBUTION_H */
