#ifndef EVENT_H
#define EVENT_H

class Event: public QueuableEntity
{
  private:
    SimObject* obj;
  protected:
    long long int time;
  public:
    Event(long long int t, int p = 50) {time = t; priority = p;};
    virtual int doit(void) {if (obj) obj->action(time, this); return 1;};
    long long int getTime() {return time;};
    virtual bool operator<(const QueuableEntity &other) const {
      if (this->time < CAST(other, const Event &).time) {
        return true;
      }
      if (this->time == CAST(other, const Event &).time) {
        return (this->priority > CAST(other, const Event &).priority);
      }
      return false;
    };
    void setObject(SimObject *o) {obj = o;};
#if 0
    void computeId();
    int getId() {return id;};
    void setTime(int t) {time=t;};
    virtual const char* getType()=0;
#endif
    virtual ~Event(){};
};
#endif
