#include <climits>

#include "simobject.hh"
#include "queuableentity.hh"
#include "priorityqueue.hh"
#include "event.hh"
#include "eventlist.hh"

EventList::EventList(void)
{
  last_time = LLONG_MAX;
}

void EventList::run(long long int time)
{
  last_time = time;

  while (getSize() != 0) {  //FIXME: getSize() != 0!!!
    Event *e;
    QueuableEntity *p;

    p = popFirst();
    e = CAST(p, Event *);
    if (e) {
      if (e->doit()) delete e;
    }
  }
}

void EventList::insert(QueuableEntity *e)
{
  Event *ev;

  ev = CAST(e, Event *);
  if (ev && (ev->getTime() < last_time)) {
    PriorityQueue::insert(e);
  } else {
    delete e;
  }
}

