#include <sstream>
#include <random>

#include "randomvar.hh"
#include "exponentialvar.hh"

ExponentialVar::ExponentialVar(double rt)
{
  rate = rt;
}

long long int ExponentialVar::sample(void)
{
  double r = ((double) rand() / (RAND_MAX));

  return (int)(-log(r) / rate * 100);
}

void ExponentialVar::dump(char *buff)
{
  std::stringstream out;

  out.rdbuf()->pubsetbuf(buff, 32/*FIXME!*/);
  out << "ExpVar(" << rate << ")";
}
