#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdlib>

#include "randomvar.hh"
#include "filevar.hh"

#define SIZE_CHUNK 100

FileVar::FileVar(const char *filename)
{
  std::ifstream in(filename);
  unsigned int size;

  size = SIZE_CHUNK;
  val  = (int    *)malloc(sizeof(int)    * size);
  prob = (double *)malloc(sizeof(double) * size);
  n = 0;
  while(in >> val[n] >> prob[n]) {
    n++;
    if (n == size) {
      size += SIZE_CHUNK;
      val  = (int    *)realloc(val, sizeof(int)    * size);
      prob = (double *)realloc(val, sizeof(double) * size);
    }
  }
}

long long int FileVar::sample(void)
{	
  double r = ((double) rand() / (RAND_MAX));
  int i = 0;

  if(n == 0 || prob[n - 1] != 1.0) {
    return -1;
  }

  while(r > prob[i]) {
    i++;
  }
	
  return val[i];
}

void FileVar::dump(char *buff)
{
  std::stringstream out;

  out.rdbuf()->pubsetbuf(buff, 32/*FIXME!*/);
  out << "FileVar";
}
