#include <iostream>

#include "statobject.hh"
#include "limitstat.hh"

LimitStat::LimitStat(int lim)
{
  limits = new int;
  limits_hit = new int;

  limits[0] = lim;
  limits_dim = 1;
  hit_count = 0;
  total = 0;
}

LimitStat::LimitStat(int *lims, int dim)
{
  limits = lims;
  limits_hit = new int[dim];
  limits_dim = dim;
  hit_count = 0;
  total = 0;
}

int* LimitStat::getLimits(void)
{
  return limits;
}

int LimitStat::getLimitsDim(void)
{
  return limits_dim;
}

double* LimitStat::getHitRatio(void)
{	
  unsigned int i;
  double* hitRatio = new double [limits_dim];
	
  for(i = 0; i < limits_dim; i++) {
    hitRatio[i] = limits_hit[i] / (double)total;
  }

  return hitRatio;
}

double LimitStat::getMissRatio(void) 
{
  return (total - hit_count) / (double) total;
}

int LimitStat::getTotal()
{
  return total;
}

void LimitStat::submit(double val)
{	
  if(val >= 0) {
    unsigned int i;

    for(i = 0; i < limits_dim; i++) {
      if(val <= limits[i]) {
        limits_hit[i]++;
        hit_count++;
        break;
      }
    }
  }
	
  total++;
}
