#include <sstream>
#include <random>

#include "randomvar.hh"
#include "normalvar.hh"

NormalVar::NormalVar(double mn, double stdev)
{
  mean = mn;
  stddev = stdev;
}

long long int NormalVar::sample(void)
{
  static const double pi = 3.14159265359;
  double r1 = ((double) rand() / (RAND_MAX));
  double r2 = ((double) rand() / (RAND_MAX));
  double z = sqrt(-2 * log(r1)) *cos(2 * pi * r2) ; 
	
  return z * stddev + mean;
}

void NormalVar::dump(char *buff)
{
  std::stringstream out;

  out.rdbuf()->pubsetbuf(buff, 32/*FIXME!*/);
  out << "NormalVar(" << mean << "," << stddev << ")";
}
