#include <math.h>

extern "C" {
#include "t_student.h"
}
#include "statobject.hh"
#include "stat.hh"

Stat::Stat(void)
{
  avg = 0;
  m2  = 0;
  max = 0;
  min = 0;
  n   = 0;
}

void Stat::submit(double val)
{
  double delta;

  if ((n == 0) || (min > val)) {
    min = val;
  }
    
  if (max < val) {
    max = val;
  }

  n++;
  delta = val - avg;
  avg = avg + delta / n;
  m2 = m2 + delta * (val - avg);
}

double Stat::getAverage(void) const
{
  return avg;
}

double Stat::getVariance(void) const
{
  if (n < 1) return -1;

  return m2 / (n - 1);
}

double Stat::getMax(void) const
{
  return max;
}

double Stat::getMin(void) const
{
  return min;
}

double Stat::getConfidence(int conf) const
{
  return get_student(n, conf) * sqrt(getVariance());
}

int Stat::getNum(void) const
{
  return n;
}
