#ifndef TRACER_H
#define TRACER_H

class Tracer {
  protected:
    std::ostream *out;
  public:
    Tracer(const char *name);
    Tracer(uint8_t *buff, int buffsize);
    virtual ~Tracer();

    virtual void TaskCreate(int pid, const char *name, uint64_t time) = 0;
    virtual void TaskDispatch(int pid, int cpu, uint64_t time) = 0;
    virtual void TaskPreempt(int pid, uint64_t time) = 0;
    virtual void JobStart(int pid, uint64_t time) = 0;
    virtual void JobFinish(int pid, uint64_t time) = 0;
#endif
#if 0
    void DeadlineSet(int pid, uint64_t time, uint64_t d);
    void DeadlinePostpone(int pid, uint64_t time, uint64_t d1, uint64_t d2);
    void DeadlineMiss(int pid, uint64_t time);
#endif
};

#if 0
From JTracer: ArrEvent EndEvt DeschedEvt SchedEvt DlinePostEvt DeadEvt
    
//    void trc_initialize(int pid, int cpu, unsigned long long int time);
//void trc_force_desch(int pid, int cpu, unsigned long long int time);
//void trc_force_deactivation(int pid, int cpu, unsigned long long int time);
};

// TASK FORMAT: size (unsigned int), type (int), time (int), task (int)
// CPU FORMAT:                                                          cpu (int)
// DLINE FORMAT:                                                        d1 (int) d2 (int)
// CREAT FORMAT:                                             task (int) name len (int) name (string)
// Arrival is a task event
// Sched, Desched, and End are CPU events...
// Create is a Task event
// DL and DL Postpone are Task Events
//                                                            task (int) name len (int) name (string)
//                                                            task (int) d (int) 
//                                                            task (int) d1 (int) d2 (int)
#endif
