#include <iostream>

#include "tracer.hh"
#include "txttracer.hh"

void TxtTracer::TaskCreate(int pid, const char *name, uint64_t time)
{
  *out << "Task " << pid << "(" << name << ") created at time " << time << std::endl;
}

void TxtTracer::TaskDispatch(int pid, int cpu, uint64_t time)
{
  *out << "Task " << pid << " dispatched on CPU " << cpu << " at time " << time << std::endl;
}

void TxtTracer::TaskPreempt(int pid, uint64_t time)
{
  *out << "Task " << pid << " preempted at time " << time << std::endl;
}

void TxtTracer::JobStart(int pid, uint64_t time)
{
  *out << "New job for task " << pid << " at time " << time << std::endl;
}

void TxtTracer::JobFinish(int pid, uint64_t time)
{
  *out << "Job of task " << pid << " finishes at time " << time << std::endl;
}
